diff --git a/src/backend/storage/file/buffile.c b/src/backend/storage/file/buffile.c
index efbede7629..ca0848dd20 100644
--- a/src/backend/storage/file/buffile.c
+++ b/src/backend/storage/file/buffile.c
@@ -47,12 +47,17 @@
 #include "storage/fd.h"
 #include "storage/buffile.h"
 #include "storage/buf_internals.h"
+#include "storage/encryption.h"
+#include "utils/datetime.h"
 #include "utils/resowner.h"
 
 /*
  * We break BufFiles into gigabyte-sized segments, regardless of RELSEG_SIZE.
  * The reason is that we'd like large BufFiles to be spread across multiple
  * tablespaces when available.
+ *
+ * The number of useful bytes is appended to each segment of shared encrypted
+ * file, see BufFile.useful.
  */
 #define MAX_PHYSICAL_FILESIZE	0x40000000
 #define BUFFILE_SEG_SIZE		(MAX_PHYSICAL_FILESIZE / BLCKSZ)
@@ -68,6 +73,35 @@ struct BufFile
 	/* all files except the last have length exactly MAX_PHYSICAL_FILESIZE */
 	File	   *files;			/* palloc'd array with numFiles entries */
 	off_t	   *offsets;		/* palloc'd array with numFiles entries */
+#ifdef USE_ENCRYPTION
+
+	/*
+	 * If the file is encrypted, only the whole buffer can be loaded / dumped
+	 * --- see BufFileLoadBuffer() for more info --- whether it's space is
+	 * used up or not. Therefore we need to keep track of the actual on-disk
+	 * size buffer of each component file, as it would be if there was no
+	 * encryption.
+	 *
+	 * List would make coding simpler, however would not contribute to
+	 * performance. Random access is important here.
+	 */
+	off_t	   *useful;
+
+	/*
+	 * The array may need to be expanded independent from extendBufFile()
+	 * (i.e. earlier than the buffer gets dumped), so store the number of
+	 * elements separate from numFiles.
+	 */
+	int			nuseful;
+
+	/*
+	 * Segment number is used to compute encryption tweak so we must remember
+	 * the original numbers of segments if the file is encrypted and if it was
+	 * passed as target to BufFileAppend() at least once. If this field is
+	 * NULL, ->curFile is used to compute the tweak.
+	 */
+	off_t	   *segnos;
+#endif
 
 	/*
 	 * offsets[i] is the current seek position of files[i].  We use this to
@@ -106,6 +140,10 @@ static void BufFileLoadBuffer(BufFile *file);
 static void BufFileDumpBuffer(BufFile *file);
 static int	BufFileFlush(BufFile *file);
 static File MakeNewSharedSegment(BufFile *file, int segment);
+#ifdef USE_ENCRYPTION
+static void BufFileTweak(char *tweak, BufFile *file);
+static void ensureUsefulArraySize(BufFile *file, int required);
+#endif
 
 /*
  * Create BufFile and perform the common initialization.
@@ -125,6 +163,28 @@ makeBufFileCommon(int nfiles)
 	file->pos = 0;
 	file->nbytes = 0;
 
+	if (data_encrypted)
+	{
+#ifdef USE_ENCRYPTION
+		file->useful = (off_t *) palloc0(sizeof(off_t) * nfiles);
+		file->nuseful = nfiles;
+		file->segnos = NULL;
+
+		/*
+		 * The unused (trailing) part of the buffer should not contain
+		 * undefined data: if we encrypt such a buffer and flush it to disk,
+		 * the encrypted form of that "undefined part" can get zeroed due to
+		 * seek and write beyond EOF. If such a buffer gets loaded and
+		 * decrypted, the change of the undefined part to zeroes can affect
+		 * the valid part if it does not end at block boundary. By setting the
+		 * whole buffer to zeroes we ensure that the unused part always
+		 * contains zeroes.
+		 */
+		MemSet(file->buffer, 0, BLCKSZ);
+#else
+		ENCRYPTION_NOT_SUPPORTED_MSG;
+#endif							/* USE_ENCRYPTION */
+	}
 	return file;
 }
 
@@ -172,6 +232,22 @@ extendBufFile(BufFile *file)
 									(file->numFiles + 1) * sizeof(File));
 	file->offsets = (off_t *) repalloc(file->offsets,
 									   (file->numFiles + 1) * sizeof(off_t));
+
+	if (data_encrypted)
+	{
+#ifdef USE_ENCRYPTION
+		ensureUsefulArraySize(file, file->numFiles + 1);
+
+		if (file->segnos)
+		{
+			file->segnos = (off_t *) repalloc(file->segnos,
+											  (file->numFiles + 1) * sizeof(off_t));
+			file->segnos[file->numFiles] = file->numFiles;
+		}
+#else
+		ENCRYPTION_NOT_SUPPORTED_MSG;
+#endif							/* USE_ENCRYPTION */
+	}
 	file->files[file->numFiles] = pfile;
 	file->offsets[file->numFiles] = 0L;
 	file->numFiles++;
@@ -302,6 +378,7 @@ BufFileOpenShared(SharedFileSet *fileset, const char *name)
 		files[nfiles] = SharedFileSetOpen(fileset, segment_name);
 		if (files[nfiles] <= 0)
 			break;
+
 		++nfiles;
 
 		CHECK_FOR_INTERRUPTS();
@@ -317,7 +394,64 @@ BufFileOpenShared(SharedFileSet *fileset, const char *name)
 				 errmsg("could not open BufFile \"%s\"", name)));
 
 	file = makeBufFileCommon(nfiles);
+
+	/*
+	 * Shared encrypted segment should contain information on the number of
+	 * useful bytes at the end.
+	 */
+	if (data_encrypted)
+	{
+#ifdef USE_ENCRYPTION
+		off_t		pos;
+		int			i;
+
+		for (i = 0; i < nfiles; i++)
+		{
+			int			nbytes;
+			File		segment = files[i];
+
+			pos = FileSeek(segment, -sizeof(off_t), SEEK_END);
+
+			/*
+			 * The word must immediately follow the last buffer of the
+			 * segment.
+			 */
+			if (pos <= 0 || pos % BLCKSZ != 0)
+				ereport(ERROR,
+						(errcode_for_file_access(),
+						 errmsg("could not find padding info in BufFile \"%s\"",
+								name)));
+
+			nbytes = FileRead(segment, (char *) &file->useful[i],
+							  sizeof(off_t), WAIT_EVENT_BUFFILE_READ);
+			if (nbytes != sizeof(off_t))
+				ereport(ERROR,
+						(errcode_for_file_access(),
+						 errmsg("could not read padding info from BufFile \"%s\"",
+								name)));
+			Assert(file->useful[i] > 0);
+
+			/*
+			 * Keep ->offsets up-to-date.
+			 */
+			file->offsets[i] = FileTell(segment);
+
+			CHECK_FOR_INTERRUPTS();
+		}
+#else
+		ENCRYPTION_NOT_SUPPORTED_MSG;
+#endif							/* USE_ENCRYPTION */
+	}
+
 	file->files = files;
+	if (data_encrypted)
+	{
+#ifdef USE_ENCRYPTION
+		file->nuseful = nfiles;
+#else
+		ENCRYPTION_NOT_SUPPORTED_MSG;
+#endif							/* USE_ENCRYPTION */
+	}
 	file->readOnly = true;		/* Can't write to files opened this way */
 	file->fileset = fileset;
 	file->name = pstrdup(name);
@@ -397,6 +531,17 @@ BufFileClose(BufFile *file)
 	/* release the buffer space */
 	pfree(file->files);
 	pfree(file->offsets);
+
+	if (data_encrypted)
+	{
+#ifdef USE_ENCRYPTION
+		if (file->segnos)
+			pfree(file->segnos);
+		pfree(file->useful);
+#else
+		ENCRYPTION_NOT_SUPPORTED_MSG;
+#endif							/* USE_ENCRYPTION */
+	}
 	pfree(file);
 }
 
@@ -404,7 +549,7 @@ BufFileClose(BufFile *file)
  * BufFileLoadBuffer
  *
  * Load some data into buffer, if possible, starting from curOffset.
- * At call, must have dirty = false, pos and nbytes = 0.
+ * At call, must have dirty = false, nbytes = 0.
  * On exit, nbytes is number of bytes loaded.
  */
 static void
@@ -413,6 +558,22 @@ BufFileLoadBuffer(BufFile *file)
 	File		thisfile;
 
 	/*
+	 * Only whole multiple of ENCRYPTION_BLOCK can be encrypted / decrypted,
+	 * but we choose to use BLCKSZ (i.e. BufFile buffer) as the unit. The
+	 * point is that curOffset is a component of the encryption tweak, and all
+	 * data within particular call of encrypt_block() / decrypt_block() must
+	 * have the same tweak. So whichever unit we choose we must stick on it
+	 * and never encrypt / decrypt multiple units at a time.
+	 *
+	 * BLCKSZ also seems better choice than ENCRYPTION_BLOCK for performance
+	 * purposes. We assume that alignment to BLCKSZ implies alignment to
+	 * ENCRYPTION_BLOCK.
+	 */
+	Assert((file->curOffset % BLCKSZ == 0 &&
+			file->curOffset % ENCRYPTION_BLOCK == 0) ||
+		   !data_encrypted);
+
+	/*
 	 * Advance to next component file if necessary and possible.
 	 */
 	if (file->curOffset >= MAX_PHYSICAL_FILESIZE &&
@@ -423,6 +584,20 @@ BufFileLoadBuffer(BufFile *file)
 	}
 
 	/*
+	 * See makeBufFile().
+	 *
+	 * Actually here we only handle the case of FileRead() returning zero
+	 * bytes below. In contrast, if the buffer contains any data but it's not
+	 * full, it should already have the trailing zeroes (encrypted) on disk.
+	 * And as the encrypted buffer is always loaded in its entirety (i.e. EOF
+	 * should only appear at buffer boundary if the data is encrypted), all
+	 * unused bytes of the buffer should eventually be zeroes after the
+	 * decryption.
+	 */
+	if (data_encrypted)
+		MemSet(file->buffer, 0, BLCKSZ);
+
+	/*
 	 * May need to reposition physical file.
 	 */
 	thisfile = file->files[file->curFile];
@@ -445,6 +620,64 @@ BufFileLoadBuffer(BufFile *file)
 	file->offsets[file->curFile] += file->nbytes;
 	/* we choose not to advance curOffset here */
 
+	if (data_encrypted && file->nbytes > 0)
+	{
+#ifdef USE_ENCRYPTION
+		char		tweak[TWEAK_SIZE];
+		int			nbytes = file->nbytes;
+
+		/*
+		 * The encrypted component file can only consist of whole number of
+		 * our encryption units. (Only the whole buffers are dumped / loaded.)
+		 * The only exception is that we're at the end of segment file and
+		 * found the word indicating the number of useful bytes in the
+		 * segment. This can only happen for shared file.
+		 */
+		if (nbytes % BLCKSZ != 0)
+		{
+			Assert(nbytes == sizeof(off_t) && file->fileset != NULL);
+
+			/*
+			 * This special word cannot start within the useful data.
+			 */
+			Assert(file->offsets[file->curFile] - nbytes >=
+				   file->useful[file->curFile]);
+
+			/*
+			 * This metadata his hidden to caller, so all he needs to know
+			 * that there's no real data at the end of the file.
+			 */
+			file->nbytes = 0;
+			return;
+		}
+
+		BufFileTweak(tweak, file);
+
+		/*
+		 * The whole block is encrypted / decrypted at once as explained
+		 * above.
+		 */
+		decrypt_block(file->buffer, file->buffer, BLCKSZ, tweak);
+
+#ifdef	USE_ASSERT_CHECKING
+
+		/*
+		 * The unused part of the buffer which we've read from disk and
+		 * decrypted should only contain zeroes, as explained in front of the
+		 * MemSet() call.
+		 */
+		{
+			int			i;
+
+			for (i = file->nbytes; i < BLCKSZ; i++)
+				Assert(file->buffer[i] == 0);
+		}
+#endif							/* USE_ASSERT_CHECKING */
+#else
+		ENCRYPTION_NOT_SUPPORTED_MSG;
+#endif							/* USE_ENCRYPTION */
+	}
+
 	if (file->nbytes > 0)
 		pgBufferUsage.temp_blks_read++;
 }
@@ -455,6 +688,9 @@ BufFileLoadBuffer(BufFile *file)
  * Dump buffer contents starting at curOffset.
  * At call, should have dirty = true, nbytes > 0.
  * On exit, dirty is cleared if successful write, and curOffset is advanced.
+ *
+ * XXX Consider separate function for encrypted buffer. (No loop is needed to
+ * dump the encrypted buffer.)
  */
 static void
 BufFileDumpBuffer(BufFile *file)
@@ -462,6 +698,52 @@ BufFileDumpBuffer(BufFile *file)
 	int			wpos = 0;
 	int			bytestowrite;
 	File		thisfile;
+	char	   *write_ptr;
+
+	/*
+	 * See comments in BufFileLoadBuffer();
+	 */
+	Assert((file->curOffset % BLCKSZ == 0 &&
+			file->curOffset % ENCRYPTION_BLOCK == 0) ||
+		   !data_encrypted);
+
+	/*
+	 * Caller's responsibility.
+	 */
+	Assert(file->pos <= file->nbytes);
+
+	if (data_encrypted)
+	{
+#ifdef USE_ENCRYPTION
+		char		tweak[TWEAK_SIZE];
+
+		BufFileTweak(tweak, file);
+
+		/*
+		 * The amount of data encrypted must be a multiple of
+		 * ENCRYPTION_BLOCK. We meet this condition simply by encrypting the
+		 * whole buffer.
+		 *
+		 * XXX Alternatively we could get the encrypted chunk length by
+		 * rounding file->nbytes up to the nearest multiple of
+		 * ENCRYPTION_BLOCK, and for decryption use the
+		 * file->useful[file->curFile] value to find out how many blocks
+		 * should be decrypted. That would reduce I/O if the buffer is mostly
+		 * empty, but (BLCKSZ / ENCRYPTION_BLOCK) calls of encrypt_block()
+		 * would be needed for full buffers. See also BufFileLoadBuffer() for
+		 * explanation why we must stick on the unit of data amount encrypted
+		 * / decrypted.
+		 */
+		if (encryption_buf_size < BLCKSZ)
+			enlarge_encryption_buffer(BLCKSZ);
+		encrypt_block(file->buffer, encryption_buffer, BLCKSZ, tweak);
+		write_ptr = encryption_buffer;
+#else
+		ENCRYPTION_NOT_SUPPORTED_MSG;
+#endif							/* USE_ENCRYPTION */
+	}
+	else
+		write_ptr = file->buffer;
 
 	/*
 	 * Unlike BufFileLoadBuffer, we must dump the whole buffer even if it
@@ -469,8 +751,6 @@ BufFileDumpBuffer(BufFile *file)
 	 */
 	while (wpos < file->nbytes)
 	{
-		off_t		availbytes;
-
 		/*
 		 * Advance to next component file if necessary and possible.
 		 */
@@ -482,31 +762,56 @@ BufFileDumpBuffer(BufFile *file)
 			file->curOffset = 0L;
 		}
 
-		/*
-		 * Determine how much we need to write into this file.
-		 */
-		bytestowrite = file->nbytes - wpos;
-		availbytes = MAX_PHYSICAL_FILESIZE - file->curOffset;
+		if (!data_encrypted)
+		{
+			off_t		availbytes;
+
+			bytestowrite = file->nbytes - wpos;
+			availbytes = MAX_PHYSICAL_FILESIZE - file->curOffset;
 
-		if ((off_t) bytestowrite > availbytes)
-			bytestowrite = (int) availbytes;
+			if ((off_t) bytestowrite > availbytes)
+				bytestowrite = (int) availbytes;
+		}
+		else
+		{
+			/*
+			 * This condition plus the alignment of curOffset to BLCKSZ
+			 * (checked above) ensure that the encrypted buffer never crosses
+			 * component file boundary.
+			 */
+			StaticAssertStmt((MAX_PHYSICAL_FILESIZE % BLCKSZ) == 0,
+							 "BLCKSZ is not whole multiple of MAX_PHYSICAL_FILESIZE");
+
+			/*
+			 * Encrypted data is dumped all at once.
+			 *
+			 * Here we don't have to check availbytes because --- according to
+			 * the assertions above --- currOffset should be lower than
+			 * MAX_PHYSICAL_FILESIZE by non-zero multiple of BLCKSZ.
+			 */
+			bytestowrite = BLCKSZ;
+		}
 
 		/*
 		 * May need to reposition physical file.
 		 */
 		thisfile = file->files[file->curFile];
+
 		if (file->curOffset != file->offsets[file->curFile])
 		{
 			if (FileSeek(thisfile, file->curOffset, SEEK_SET) != file->curOffset)
 				return;			/* seek failed, give up */
+
 			file->offsets[file->curFile] = file->curOffset;
 		}
 		bytestowrite = FileWrite(thisfile,
-								 file->buffer + wpos,
+								 write_ptr + wpos,
 								 bytestowrite,
 								 WAIT_EVENT_BUFFILE_WRITE);
-		if (bytestowrite <= 0)
+		if (bytestowrite <= 0 ||
+			(data_encrypted && bytestowrite != BLCKSZ))
 			return;				/* failed to write */
+
 		file->offsets[file->curFile] += bytestowrite;
 		file->curOffset += bytestowrite;
 		wpos += bytestowrite;
@@ -515,25 +820,130 @@ BufFileDumpBuffer(BufFile *file)
 	}
 	file->dirty = false;
 
-	/*
-	 * At this point, curOffset has been advanced to the end of the buffer,
-	 * ie, its original value + nbytes.  We need to make it point to the
-	 * logical file position, ie, original value + pos, in case that is less
-	 * (as could happen due to a small backwards seek in a dirty buffer!)
-	 */
-	file->curOffset -= (file->nbytes - file->pos);
-	if (file->curOffset < 0)	/* handle possible segment crossing */
+	if (!data_encrypted)
 	{
-		file->curFile--;
-		Assert(file->curFile >= 0);
-		file->curOffset += MAX_PHYSICAL_FILESIZE;
+		/*
+		 * At this point, curOffset has been advanced to the end of the
+		 * buffer, ie, its original value + nbytes.  We need to make it point
+		 * to the logical file position, ie, original value + pos, in case
+		 * that is less (as could happen due to a small backwards seek in a
+		 * dirty buffer!)
+		 */
+		file->curOffset -= (file->nbytes - file->pos);
+		if (file->curOffset < 0)	/* handle possible segment crossing */
+		{
+			file->curFile--;
+			Assert(file->curFile >= 0);
+			file->curOffset += MAX_PHYSICAL_FILESIZE;
+		}
+
+		/*
+		 * Now we can set the buffer empty without changing the logical
+		 * position
+		 */
+		file->pos = 0;
+		file->nbytes = 0;
 	}
+	else
+	{
+		/*
+		 * curOffset should be at buffer boundary and buffer is the smallest
+		 * I/O unit for encrypted data.
+		 */
+		Assert(file->curOffset % BLCKSZ == 0);
 
-	/*
-	 * Now we can set the buffer empty without changing the logical position
-	 */
-	file->pos = 0;
-	file->nbytes = 0;
+		/*
+		 * The number of useful bytes needs to be written at the end of each
+		 * encrypted segment of a shared file so that the other backends know
+		 * how many bytes of the last buffer are useful.
+		 */
+		if (file->fileset != NULL)
+		{
+			off_t		useful;
+
+#ifdef USE_ENCRYPTION
+
+			/*
+			 * nuseful may be increased earlier than numFiles but not later,
+			 * so the corresponding entry should always exist in ->useful.
+			 */
+			Assert(file->curFile < file->nuseful);
+
+			/*
+			 * The number of useful bytes in the current segment file.
+			 */
+			useful = file->useful[file->curFile];
+#endif
+
+			/*
+			 * Have we dumped the last buffer of the segment, i.e. the one
+			 * that can contain padding?
+			 */
+			if (file->curOffset >= useful)
+			{
+				int			bytes_extra;
+
+				/*
+				 * Write the number of useful bytes in the segment.
+				 */
+				bytes_extra = FileWrite(thisfile,
+										(char *) &useful,
+										sizeof(useful),
+										WAIT_EVENT_BUFFILE_WRITE);
+				if (bytes_extra != sizeof(useful))
+					return;		/* failed to write */
+
+				/*
+				 * Remember the file position at OS level, but do not increase
+				 * curOffset. That ensures that the next buffer appended will
+				 * overwrite the "useful" value just written, instead of being
+				 * appended to it.
+				 *
+				 * XXX The additional seek backwards at OS level when the next
+				 * buffer is gonna be written is hard to avoid by writing this
+				 * info higher in the stack (e.g. in BufFileWrite() or
+				 * BufFileFlush()). Once we've cleared the "dirty" flag, we
+				 * cannot recognize easily later that the number of useful
+				 * bytes might need to be updated on disk because of this
+				 * buffer. Is it worth introducing another bool field and
+				 * making the logic trickier?
+				 */
+				file->offsets[file->curFile] += bytes_extra;
+			}
+		}
+
+		if (file->pos >= BLCKSZ)
+		{
+			Assert(file->pos == BLCKSZ);
+
+			/*
+			 * curOffset points to the beginning of the next buffer, so just
+			 * reset pos and nbytes.
+			 */
+			file->pos = 0;
+			file->nbytes = 0;
+
+			/* See makeBufFile() */
+			if (data_encrypted)
+				MemSet(file->buffer, 0, BLCKSZ);
+		}
+		else
+		{
+			/*
+			 * Move curOffset to the beginning of the just-written buffer and
+			 * preserve pos.
+			 */
+			file->curOffset -= BLCKSZ;
+
+			/*
+			 * At least pos bytes should be written even if the first change
+			 * since now appears at pos == nbytes, but in fact the whole
+			 * buffer will be written regardless pos. This is the price we pay
+			 * for the choosing BLCKSZ as the I/O unit for encrypted data.
+			 */
+			file->nbytes = BLCKSZ;
+		}
+	}
 }
 
 /*
@@ -556,18 +966,107 @@ BufFileRead(BufFile *file, void *ptr, size_t size)
 
 	while (size > 0)
 	{
+		int			avail;
+
 		if (file->pos >= file->nbytes)
 		{
+			/*
+			 * Neither read nor write nor seek should leave pos greater than
+			 * nbytes, regardless the data is encrypted or not. pos can only
+			 * be greater if nbytes is zero --- this situation can be caused
+			 * by BufFileSeek().
+			 */
+			Assert(file->pos == file->nbytes || file->nbytes == 0);
+
+			/*
+			 * The Assert() above implies that pos is a whole multiple of
+			 * BLCKSZ, so curOffset has meet the same encryption-specific
+			 * requirement too.
+			 */
+			Assert(file->curOffset % BLCKSZ == 0 || !data_encrypted);
+
 			/* Try to load more data into buffer. */
-			file->curOffset += file->pos;
-			file->pos = 0;
-			file->nbytes = 0;
-			BufFileLoadBuffer(file);
-			if (file->nbytes <= 0)
-				break;			/* no more data available */
+			if (!data_encrypted || file->pos % BLCKSZ == 0)
+			{
+				file->curOffset += file->pos;
+				file->pos = 0;
+				file->nbytes = 0;
+				BufFileLoadBuffer(file);
+				if (file->nbytes <= 0)
+					break;		/* no more data available */
+			}
+			else
+			{
+				int			nbytes_orig = file->nbytes;
+
+				/*
+				 * Given that BLCKSZ is the I/O unit for encrypted data (see
+				 * comments in BufFileLoadBuffer()), we cannot add pos to
+				 * curOffset because that would make it point outside block
+				 * boundary. The only thing we can do is to reload the whole
+				 * buffer and see if more data is eventually there than the
+				 * previous load has fetched.
+				 */
+				BufFileLoadBuffer(file);
+				if (file->nbytes <= nbytes_orig)
+					break;		/* no more data available */
+			}
+		}
+
+		avail = file->nbytes;
+		nthistime = avail - file->pos;
+
+		/*
+		 * The buffer can contain trailing zeroes because BLCKSZ is the I/O
+		 * unit for encrypted data. These are not available for reading.
+		 */
+		if (data_encrypted)
+		{
+#ifdef USE_ENCRYPTION
+			off_t		useful = file->useful[file->curFile];
+
+			/*
+			 * The criterion is whether the useful data end within the
+			 * currently loaded buffer.
+			 */
+			if (useful < file->curOffset + BLCKSZ)
+			{
+				/*
+				 * Compute the number of bytes available in the current
+				 * buffer.
+				 */
+				avail = useful - file->curOffset;
+				Assert(avail >= 0);
+
+				/*
+				 * An empty buffer can exist, e.g. after a seek to the end of
+				 * the last component file.
+				 */
+				if (avail == 0)
+					break;
+
+				/*
+				 * Seek beyond the current EOF, which was not followed by
+				 * write, could have resulted in position outside the useful
+				 * data
+				 */
+				if (file->pos > avail)
+					break;
+
+				nthistime = avail - file->pos;
+				Assert(nthistime >= 0);
+
+				/*
+				 * Have we reached the end of the valid data?
+				 */
+				if (nthistime == 0)
+					break;
+			}
+#else
+			ENCRYPTION_NOT_SUPPORTED_MSG;
+#endif							/* USE_ENCRYPTION */
 		}
 
-		nthistime = file->nbytes - file->pos;
 		if (nthistime > size)
 			nthistime = size;
 		Assert(nthistime > 0);
@@ -609,11 +1108,28 @@ BufFileWrite(BufFile *file, void *ptr, size_t size)
 			}
 			else
 			{
-				/* Hmm, went directly from reading to writing? */
+				/*
+				 * Hmm, went directly from reading to writing?
+				 *
+				 * As pos should be exactly BLCKSZ, there is nothing special
+				 * to do about data_encrypted. Except for zeroing the buffer.
+				 */
+				Assert(file->pos == BLCKSZ);
+
 				file->curOffset += file->pos;
 				file->pos = 0;
 				file->nbytes = 0;
+
+				/* See makeBufFile() */
+				if (data_encrypted)
+					MemSet(file->buffer, 0, BLCKSZ);
 			}
+
+			/*
+			 * If curOffset changed above, it should still meet the assumption
+			 * that buffer is the I/O unit for encrypted data.
+			 */
+			Assert(file->curOffset % BLCKSZ == 0 || !data_encrypted);
 		}
 
 		nthistime = BLCKSZ - file->pos;
@@ -627,6 +1143,65 @@ BufFileWrite(BufFile *file, void *ptr, size_t size)
 		file->pos += nthistime;
 		if (file->nbytes < file->pos)
 			file->nbytes = file->pos;
+
+		if (data_encrypted)
+		{
+#ifdef USE_ENCRYPTION
+			off_t		new_offset;
+			int			fileno = file->curFile;
+
+			/*
+			 * curFile does not necessarily correspond to the offset: it can
+			 * still have the initial value if BufFileSeek() skipped the
+			 * previous file w/o dumping anything of it. While curFile will be
+			 * fixed during the next dump, we need valid fileno now.
+			 */
+			if (file->curOffset >= MAX_PHYSICAL_FILESIZE)
+			{
+				/*
+				 * Even BufFileSeek() should not allow curOffset to become
+				 * more than MAX_PHYSICAL_FILESIZE (if caller passes higher
+				 * offset, curFile gets increased instead).
+				 */
+				Assert(file->curOffset == MAX_PHYSICAL_FILESIZE);
+
+				fileno++;
+			}
+
+			/*
+			 * fileno can point to a segment that does not exist on disk yet.
+			 */
+			ensureUsefulArraySize(file, fileno + 1);
+
+			/*
+			 * Update the "useful offset" of the underlying component file if
+			 * we've added any useful data.
+			 */
+			new_offset = file->curOffset + file->pos;
+
+			/*
+			 * Make sure the offset is relative to the correct component file.
+			 * It should have been adjusted during sequential write, but if
+			 * we've just used BufFileSeek() to jump to segment boundary w/o
+			 * writing, the value is relative to the start of the *previous*
+			 * segment.
+			 */
+			if (file->curOffset % MAX_PHYSICAL_FILESIZE == 0)
+				new_offset %= MAX_PHYSICAL_FILESIZE;
+
+			/*
+			 * Adjust the number of useful bytes in the file if needed. This
+			 * has to happen immediately, independent from
+			 * BufFileDumpBuffer(), so that BufFileRead() works correctly
+			 * anytime.
+			 */
+			if (new_offset > file->useful[fileno])
+				file->useful[fileno] = new_offset;
+#else
+			ENCRYPTION_NOT_SUPPORTED_MSG;
+#endif							/* USE_ENCRYPTION */
+		}
+
 		ptr = (void *) ((char *) ptr + nthistime);
 		size -= nthistime;
 		nwritten += nthistime;
@@ -741,9 +1316,43 @@ BufFileSeek(BufFile *file, int fileno, off_t offset, int whence)
 		return EOF;
 	/* Seek is OK! */
 	file->curFile = newFile;
-	file->curOffset = newOffset;
-	file->pos = 0;
-	file->nbytes = 0;
+	if (!data_encrypted)
+	{
+		file->curOffset = newOffset;
+		file->pos = 0;
+		file->nbytes = 0;
+	}
+	else
+	{
+		/*
+		 * Offset of an encrypted buffer must be a multiple of BLCKSZ.
+		 */
+		file->pos = newOffset % BLCKSZ;
+		file->curOffset = newOffset - file->pos;
+
+		/*
+		 * BufFileLoadBuffer() will set nbytes iff it can read something.
+		 */
+		file->nbytes = 0;
+
+		/*
+		 * Load and decrypt the existing part of the buffer.
+		 */
+		BufFileLoadBuffer(file);
+		if (file->nbytes == 0)
+		{
+			/*
+			 * The data requested is not in the file, but this is not an
+			 * error.
+			 */
+			return 0;
+		}
+
+		/*
+		 * The whole buffer should have been loaded.
+		 */
+		Assert(file->nbytes == BLCKSZ);
+	}
 	return 0;
 }
 
@@ -774,6 +1383,55 @@ BufFileSeekBlock(BufFile *file, long blknum)
 					   SEEK_SET);
 }
 
+#ifdef USE_ENCRYPTION
+static void
+BufFileTweak(char *tweak, BufFile *file)
+{
+	off_t		block;
+	int			curFile = file->curFile;
+
+	/*
+	 * If the file was produced by BufFileAppend(), we need the original
+	 * curFile, as it was used originally for encryption.
+	 */
+	if (file->segnos)
+		curFile = file->segnos[curFile];
+
+	block = curFile * BUFFILE_SEG_SIZE + file->curOffset / BLCKSZ;
+
+	/*
+	 * The unused bytes should always be defined.
+	 */
+	memset(tweak, 0, TWEAK_SIZE);
+	StaticAssertStmt(sizeof(block) <= TWEAK_SIZE,
+					 "block number does not fit into encryption tweak");
+	memcpy(tweak, &block, sizeof(off_t));
+}
+
+/*
+ * Make sure that BufFile.useful array has the required size.
+ */
+static void
+ensureUsefulArraySize(BufFile *file, int required)
+{
+	/*
+	 * Does the array already have enough space?
+	 */
+	if (required <= file->nuseful)
+		return;
+
+	/*
+	 * It shouldn't be possible to jump beyond the end of the last segment,
+	 * i.e. skip more than 1 segment.
+	 */
+	Assert(file->nuseful + 1 == required);
+
+	file->useful = (off_t *) repalloc(file->useful, required * sizeof(off_t));
+	file->useful[file->nuseful] = 0L;
+	file->nuseful++;
+}
+#endif
+
 #ifdef NOT_USED
 /*
  * BufFileTellBlock --- block-oriented tell
@@ -803,11 +1461,33 @@ BufFileSize(BufFile *file)
 {
 	off_t		lastFileSize;
 
-	/* Get the size of the last physical file by seeking to end. */
-	lastFileSize = FileSeek(file->files[file->numFiles - 1], 0, SEEK_END);
-	if (lastFileSize < 0)
-		return -1;
-	file->offsets[file->numFiles - 1] = lastFileSize;
+	if (data_encrypted)
+	{
+#ifdef USE_ENCRYPTION
+		/*
+		 * "useful" should be initialized even for shared file, see
+		 * BufFileOpenShared().
+		 */
+		Assert(file->useful != NULL && file->nuseful >= file->numFiles);
+
+		/*
+		 * The number of useful bytes in the segment is what caller is
+		 * interested in.
+		 */
+		lastFileSize = file->useful[file->nuseful - 1];
+#else
+		ENCRYPTION_NOT_SUPPORTED_MSG;
+#endif							/* USE_ENCRYPTION */
+	}
+	else
+	{
+		/* Get the size of the last physical file by seeking to end. */
+		lastFileSize = FileSeek(file->files[file->numFiles - 1], 0, SEEK_END);
+		if (lastFileSize < 0)
+			return -1;
+
+		file->offsets[file->numFiles - 1] = lastFileSize;
+	}
 
 	return ((file->numFiles - 1) * (off_t) MAX_PHYSICAL_FILESIZE) +
 		lastFileSize;
@@ -837,6 +1517,9 @@ BufFileAppend(BufFile *target, BufFile *source)
 {
 	long		startBlock = target->numFiles * BUFFILE_SEG_SIZE;
 	int			newNumFiles = target->numFiles + source->numFiles;
+#ifdef USE_ENCRYPTION
+	int			newNUseful = target->nuseful + source->nuseful;
+#endif
 	int			i;
 
 	Assert(target->fileset != NULL);
@@ -851,11 +1534,75 @@ BufFileAppend(BufFile *target, BufFile *source)
 		repalloc(target->files, sizeof(File) * newNumFiles);
 	target->offsets = (off_t *)
 		repalloc(target->offsets, sizeof(off_t) * newNumFiles);
+
 	for (i = target->numFiles; i < newNumFiles; i++)
 	{
-		target->files[i] = source->files[i - target->numFiles];
-		target->offsets[i] = source->offsets[i - target->numFiles];
+		int			n = i - target->numFiles;
+
+		target->files[i] = source->files[n];
+		target->offsets[i] = source->offsets[n];
 	}
+
+	if (data_encrypted)
+	{
+#ifdef USE_ENCRYPTION
+		/*
+		 * XXX As the typical use case is that parallel workers expose file to
+		 * the leader, can we expect both target and source to have been
+		 * exported, i.e. flushed? In such a case "nuseful" would have to be
+		 * equal to "numFiles" for both input files and the code could get a
+		 * bit simpler. It seems that at least source should be flushed, as
+		 * source->readOnly is expected to be true above.
+		 */
+		target->useful = (off_t *)
+			repalloc(target->useful, sizeof(off_t) * newNUseful);
+
+		for (i = target->nuseful; i < newNUseful; i++)
+			target->useful[i] = source->useful[i - target->nuseful];
+		target->nuseful = newNUseful;
+
+		/*
+		 * File segments can appear at different position due to
+		 * concatenation, so make sure we remember the original positions for
+		 * the sake of encryption tweak.
+		 */
+		if (target->segnos == NULL)
+		{
+			/*
+			 * If the target does not have the array yet, allocate it for both
+			 * target and source and initialize the target part.
+			 */
+			target->segnos = (off_t *) palloc(newNumFiles * sizeof(off_t));
+			for (i = 0; i < target->numFiles; i++)
+				target->segnos[i] = i;
+		}
+		else
+		{
+			/*
+			 * Use the existing target part and add space for the source part.
+			 */
+			target->segnos = (off_t *) repalloc(target->segnos,
+												newNumFiles * sizeof(off_t));
+		}
+
+		/*
+		 * The source segment number either equals to (0-based) index of the
+		 * segment, or to an element of an already existing array.
+		 */
+		for (i = target->numFiles; i < newNumFiles; i++)
+		{
+			off_t		segno = i - target->numFiles;
+
+			if (source->segnos == NULL)
+				target->segnos[i] = segno;
+			else
+				target->segnos[i] = source->segnos[segno];
+		}
+#else
+		ENCRYPTION_NOT_SUPPORTED_MSG;
+#endif							/* USE_ENCRYPTION */
+	}
+
 	target->numFiles = newNumFiles;
 
 	return startBlock;
